/**
 * Program skeleton for the course "Programming embedded systems"
 */

#include <stdio.h>

/* Scheduler includes. */
#include "FreeRTOS.h"
#include "stm32f10x_conf.h"
#include "task.h"
#include "setup.h"

/*-----------------------------------------------------------*/

void myTask(void *params) {
  for (;;) {
    volatile int i;
    printf("I'm running! I'm running!\n");
	for (i = 0; i < 100000; ++i);
  }
  assert(0);
}

/*
 * Entry point of program execution
 */
int main( void )
{
  prvSetupHardware();

  xTaskCreate(myTask,   // pointer to task function
              "myTask",	// name of task
			  100,      // size of stack: 100 words = 400 byte
			            // should be at least configMINIMAL_STACK_SIZE
			  NULL,     // task parameters
			  1,        // priority: number between
			            // 0 and (configMAX_PRIORITIES - 1)
			  NULL      // handle to the task
			  );

  vTaskStartScheduler();
  assert(0);
  return 0;                 // not reachable
}
/*-----------------------------------------------------------*/


