/**
 * Program skeleton for the course "Programming embedded systems"
 */

#include <stdio.h>

/* Scheduler includes. */
#include "FreeRTOS.h"
#include "stm32f10x_conf.h"
#include "task.h"
#include "setup.h"

/*-----------------------------------------------------------*/

void myTask(void *params) {
  portTickType wakeTime;
  char *str = (char*)params;

  wakeTime = xTaskGetTickCount();

  for (;;) {
    printf("\n%s %d\n\n", str, xTaskGetTickCount());
	vTaskDelayUntil(&wakeTime, 10 / portTICK_RATE_MS);
  }
  assert(0);
}

void fib(void *params) {
  int a = 0, b = 1;

  for (;;) {
    int t;
    printf("%d\n", a);
    t = b;
    b = a + b;
    a = t;
  }
}

static char *str1 = "I'm running!";

/*
 * Entry point of program execution
 */
int main( void )
{
  prvSetupHardware();

  xTaskCreate(myTask,   // pointer to task function
              "myTask",	// name of task
			  100,      // size of stack: 100 words = 400 byte
			            // should be at least configMINIMAL_STACK_SIZE
			  str1,     // task parameters
			  2,        // priority: number between
			            // 0 and (configMAX_PRIORITIES - 1)
			  NULL      // handle to the task
			  );
   
  xTaskCreate(fib,   // pointer to task function
              "Fibo task",	// name of task
			  100,      // size of stack: 100 words = 400 byte
			            // should be at least configMINIMAL_STACK_SIZE
			  NULL,     // task parameters
			  1,        // priority: number between
			            // 0 and (configMAX_PRIORITIES - 1)
			  NULL      // handle to the task
			  );

  vTaskStartScheduler();
  assert(0);
  return 0;                 // not reachable
}
/*-----------------------------------------------------------*/


